/**
 * 检查更新，更新资源文件
 * @param {Object} showTip 是否显示提示,默认：false
 * @param {Object} openBrowserDownload 是否打开浏览器进行完整下载，默认：false
 */
function _checkUpdateWgt(showTip,openBrowserDownload)
{
//	if(plus.os.name == "iOS")
//		return ;
	if(openBrowserDownload == null)
		openBrowserDownload = false ;
	// 获取本地应用资源版本号
    plus.runtime.getProperty(plus.runtime.appid,function(inf){
        var param = new Object();
		param.appId = plus.runtime.appid ;
		param.name = "应急联动(公众版)" ;
		param.version = inf.version ;
		param.imei = plus.device.imei ;
		param.os = plus.os.name ;
		param.engineVersion = plus.runtime.innerVersion ;
		param.type = "Phone" ;
		sendData("wap.frame!checkUpdate.sh",param,function(data){
			if(data.msgType == "failure")
			{
				if(showTip == true && data.msgStr!="")
					showInfo("提示",data.msgStr) ;
				return ;
			}
		    //清除临时目录
			if(data.engineUpdate == "false")
		    	__deleteUpdateTempFile("_doc/update/"+data.fileName) ;
		    
//		    layer.open({
//			    type: 1
//			    ,content: '<div style="padding:1em;">'+data.msgStr+'</div>'
//			    ,anim: true
//			    ,title:"在线更新"
//		    	,btn: ["立即更新", "取 消"]
//		    	,btnCallback:function(index,btnIndex){
//		    		if (0 == btnIndex) 
//					{
//						if(data.url == null || data.url=="")
//						{
//							mui.toast("更新资源文件地址错误!") ;
//							return ;
//						}
//						if(openBrowserDownload == true || data.engineUpdate == "true")
//						{
//							if(data.engineUpdate == "false")
//								plus.runtime.openURL(data.url2);
//							else
//								plus.runtime.openURL(data.url);
//						}
//						else
//							_downWgt(data.url,data.fileName) ;
//					}
//		    		layer.close(index) ;
//		    	}
//			});
		    
			plus.nativeUI.confirm(data.msgStr, function(event) {
				if (0 == event.index) 
				{
					if(data.url == null || data.url=="")
					{
						mui.toast("更新资源文件地址错误!") ;
						return ;
					}
					if(openBrowserDownload == true || data.engineUpdate == "true")
					{
						if(data.engineUpdate == "false")
							plus.runtime.openURL(data.url2);
						else
							plus.runtime.openURL(data.url);
					}
					else
						_downWgt(data.url,data.fileName) ;
				}
			}, "在线更新", ["立即更新", "取 消"]);
		},{
			isSilence:!showTip
		}) ;
    });
}

var __updateFileLastedDownloadedSizeTime = new Date().getTime() ;
/**
 * 下载资源包
 * @param {Object} wgtUrl
 */
function _downWgt(wgtUrl,fileName)
{
	if(fileName == null)
		fileName = "";
    __showUpdateWaiting("正在下载资源文件...");
    var dtask = plus.downloader.createDownload( wgtUrl, {filename:"_doc/update/"+fileName}, function(d,status){
        if ( status == 200 ) {
            window.setTimeout(function(){
            	_installWgt(d.filename);
            },3000) ;
        } else {
            mui.toast("下载更新文件失败！");
            __closeUpdateWaiting() ;
        }
    }) ;
    dtask.addEventListener("statechanged", function(download, status){
    	if(status != 200)
    		return ;
    	if(download.state == 3)
    	{
    		var curTime = new Date().getTime() ;
    		//更新太频繁时取消更新，防止循环太多而造成卡死
    		if((curTime - __updateFileLastedDownloadedSizeTime) < 500)
    			return ;
    		__updateFileLastedDownloadedSizeTime = curTime ;
    		
	    	var str = "下载文件： " + parseInt(download.downloadedSize/1024) + "/" + parseInt(download.totalSize/1024) +"KB" ;
	    	__showUpdateWaiting(str) ;
    	}
    	else if(download.state == 4) //下载完成
    	{
    		var dsize = download.totalSize/1024/1024 ;
    		var str = "更新文件下载完成：" + dsize.toFixed(2) +"M" ;
	    	__showUpdateWaiting(str) ;
    	}
    }, false );
    dtask.start();
}

/**
 * 安装资源包
 * @param {Object} path
 */
function _installWgt(path)
{
   	__showUpdateWaiting("正在更新资源文件...");
    plus.runtime.install(path,{},function(){
        __closeUpdateWaiting() ;
        plus.ui.confirm("应用资源更新完成！", function(event) {
			localStorage.HELPER_AUTO_LOGIN = 'false' ; 
			if (0 == event.index) 
			{
				plus.runtime.restart();
			}
		}, "更新完成", ["立即重启", "取 消"]);
    },function(e){
        __closeUpdateWaiting() ;
        plus.nativeUI.alert("更新失败["+e.code+"]："+e.message);
    });
}

var ___showWaitingWinObj = -1 ;

/**
 * 显示下载等待提示框
 * @param {Object} title
 */
function __showUpdateWaiting(title)
{
//	if(window.___showWaitingWinObj == null)
//  	window.___showWaitingWinObj = plus.nativeUI.showWaiting(title);
//  else
//  	___showWaitingWinObj.setTitle(title) ;
	if(___showWaitingWinObj == -1)
    {
		var content = '<span id="loadingContent">'+title+'</span>' ;
		___showWaitingWinObj = showLoadingWithLayer(content) ;
    }
    else
    {
    	if(document.getElementById("loadingContent"))
    		document.getElementById("loadingContent").innerHTML = title ;
    }
}

/**
 * 关闭弹出对话框
 */
function __closeUpdateWaiting()
{
	if(___showWaitingWinObj == -1)
		return ;
	layer.close(___showWaitingWinObj) ;
	___showWaitingWinObj = -1 ;
//  window.___showWaitingWinObj.close() ;
//  window.___showWaitingWinObj = null ;
}

/**
 * 删除更新的临时目录文件夹文件
 */
function __deleteUpdateTempFile(url)
{
	plus.io.resolveLocalFileSystemURL(url, function(entry) {
		if(entry.isDirectory == true)
			return ;
        entry.remove(function(entry) {
//          mui.toast("文件删除成功==");
        }, function(e) {
//          mui.toast("文件删除失败=" + e.message);
        });
    });
}
