initApp() ;

mui.ready(function() {
	mui('.mui-scroll-wrapper').scroll({
		deceleration: 0.0005,
		bounce:false
	});
	loadMap() ;
});

mui.plusReady(function(){
	plus.nativeUI.closeWaiting() ;
}) ;

function setCurrentPoint()
{
	var latitude = localStorage.PDIS_W__latitude ;
	var longitude = localStorage.PDIS_W__longitude ;
	if(latitude == null || latitude == "")
	{
		longitude = 107.98535257 ;
		latitude = 26.58399177 ;
	}
	
	window.point = new BMap.Point(longitude, latitude);
	var convertor = new BMap.Convertor();
	var pointArr = [];
	pointArr.push(point);
	convertor.translate(pointArr, 1, 5, function (data){
		if(data.status === 0)
		{
			window.point = data.points[0] ;
			map.centerAndZoom(point, 15);
		}
	}) ;
	
}

function loadMap()
{
	window.map = new BMap.Map("mapDiv");
	setCurrentPoint() ;
	
	var navigation = new BMap.NavigationControl({
		type:BMAP_NAVIGATION_CONTROL_ZOOM,
		anchor:BMAP_ANCHOR_BOTTOM_RIGHT,
		enableGeolocation: true});
	map.addControl(navigation);
	
	var geolocationControl = new BMap.GeolocationControl();
	geolocationControl.addEventListener("locationSuccess", function(e){
	}) ;
	
	map.addControl(geolocationControl);
	
	map.addEventListener("tilesloaded",serarchLocalPolice);
	map.addEventListener("moveend",serarchLocalPolice);
	map.addEventListener("zoomend",serarchLocalPolice);
	map.addEventListener("dragend",serarchLocalPolice);
}

function serarchLocalPolice()
{
	var html = [] ;
	var local = new BMap.LocalSearch(map, {
		pageCapacity:20,
		onSearchComplete:function(results){
			if (local.getStatus() != BMAP_STATUS_SUCCESS)
				return ;
			for (var i = results.getCurrentNumPois()-1; i >= 0 ; i--)
			{
				var poiPoint = results.getPoi(i).point ;
				var dataId = "a_" + poiPoint.lng + "_" + poiPoint.lat ;
				if(checkHasContainInMap(dataId) == false)
				{
					marker = new BMap.Marker(poiPoint);
					marker.dataId = dataId ;
					marker.setTitle(results.getPoi(i).title) ;
					map.addOverlay(marker);
				}
				
				html.push('<li class="mui-table-view-cell mui-media" dataId="' + dataId + '">') ;
				html.push('<span class="mui-media-object mui-pull-right">') ;
				var distance = map.getDistance(point,poiPoint).toFixed() ;
				html.push(distance+"米") ;
				html.push('</span>') ;
				html.push('<div class="mui-media-body listNearPolice">') ;
				html.push(results.getPoi(i).title) ;
				html.push('<p class="mui-ellipsis">') ;
				html.push(results.getPoi(i).address) ;
				html.push('</p>') ;
				var phone = results.getPoi(i).phoneNumber ;
				if(phone != null && phone != "")
				{
					html.push('<p class="mui-ellipsis" style="color:blue;">') ;
					html.push(phone) ;
					html.push('</p>') ;
				}
				html.push('</div>') ;
				html.push('</li>') ;
			}
			
			document.getElementById("nearPolicyDiv").innerHTML = html.join('') ;
			afterLoadPolice() ;
		}
	});
	local.searchInBounds("派出所", map.getBounds());
}

var lastClickLabel = null ;
function afterLoadPolice()
{
	mui("#nearPolicyDiv").off("tap","li") ;
	mui("#nearPolicyDiv").on("tap","li",function(){
		var dataId = this.getAttribute("dataId");
		var markers = map.getOverlays() ;
		for(var i=0; i<markers.length; i++)
		{
			var marker = markers[i] ;
			if(marker.dataId == dataId)
			{
				if(lastClickLabel == null)
				{
					lastClickLabel = new BMap.Label(marker.getTitle(),{offset:new BMap.Size(20,-10)});
					lastClickLabel.setStyle({borderColor:"#a0a0a0"}) ;
				}
				else
					lastClickLabel.setContent(marker.getTitle()) ;
				marker.setLabel(lastClickLabel);
				map.setCenter(marker.getPosition()) ;
				mui.toast(marker.getTitle()) ;
				return ;
			}
		}
	}) ;
}

function checkHasContainInMap(dataId)
{
	if(dataId == null || dataId == "")
		return false ;
	var markers = map.getOverlays() ;
	for(var i=0; i<markers.length; i++)
	{
		var marker = markers[i] ;
		if(marker.dataId == dataId)
			return true ;
	}
	return false ;
}
